#include <string>
#ifdef __APPLE__
#include <GL/glew.h>
#else
#include <OpenGL/glew.h>
#endif
#include <assimp/scene.h>

class Material {
	public:
		Material(const aiMaterial &aiMaterial, const aiScene &aiScene, GLuint progId);
		void bind() const;
	private:
		GLuint progId;
		aiColor4D ambient, diffuse, specular;

		struct Texture {
			Texture(const aiString file, const aiScene &aiScene);
			GLuint texId;
		};
		Texture *albedo = nullptr;
		Texture *normal = nullptr;
		Texture *metallicRoughness = nullptr;
		Texture *ambientOcclusion = nullptr;
};

