#include <vector>
#include <string>
class ControlWindowDelegate {
	public:
		virtual void weightChanged(int, float) = 0;
		virtual void solveWeights(std::vector<float> &) = 0;
		virtual void resetManipulators() = 0;
		virtual void playbackChanged(bool playing) = 0;
};

struct ControlWindow {
	void *window, *controller;
};

ControlWindow createControlWindow(std::vector<std::string> names, ControlWindowDelegate *delegate);
void updateWeights(ControlWindow *cw, std::vector<float> weights);

bool isPanelFocused(ControlWindow cw);
